<?php
/**
 * Class AjaxValidator
 * 
 * Uses the validator class to validate FormHandler fields on the fly.
 * 
 * @since 03-12-2008
 * @author Johan Wiegel @ PHP-GLOBE
 * @package FormHandler
 * 
 */

class AjaxValidator
{
	function AjaxValidator(  )
	{
		//
	}

	function CreateObservers( $oForm )
	{
		static $bSetJS = false;

		// needed javascript included yet ?
		if(!$bSetJS)
		{
			$bSetJS = true;

			// add the needed javascript
			$oForm->_setJS( FH_FHTML_DIR."js/lib/prototype.js", true );
			$oForm->_setJS( FH_FHTML_DIR."js/ajax_validator.js", true,false );

			// create observers for all fields with a validator
			$sScript = "function FH_AJAX_VALIDATOR_init( )\n{\n";
			/*@var $oForm FormHandler*/

			foreach( $oForm->_fields AS $sField => $aField )
			{
				if( is_object( $aField[1]) && method_exists( $aField[1], 'getValidator' ) )
				{
					if( isset( $oForm->_customMsg[$sField][0] ) AND $oForm->_customMsg[$sField][0] != '' )
					{
						$sMsg = addslashes( $oForm->_customMsg[$sField][0] );
					}
					else
					{
						$sMsg = $oForm->_text(14);
					}
					
					// only when a validator is defined for this field
					if( $aField[1]->getValidator() != '' )
					{
						if( is_a( $aField[1], 'selectField' ) )
						{
							$sEvent = 'change';
						}
						elseif( is_a( $aField[1], 'checkBox' ) )
						{
							// no on the fly checking yet
							$sEvent = '';
							//$sScript .= "  $$('input[name=\"".$sField."[]\"]').each(function(e){ Event.observe( e.id, 'change', function(){ FH_VALIDATE( '".$aField[1]->getValidator()."',e.id, '".$sField."','".FH_FHTML_DIR."','".FH_INCLUDE_DIR."','".$sMsg."' ); } ) } ); \n";
						}
						elseif( is_a( $aField[1], 'radioButton' ) )
						{
							// no on the fly checking yet
							$sEvent = '';
							//$sScript .= "  $$('input[name=\"".$sField."\"]').each(function(e){ Event.observe( e.id, 'change', function(){ FH_VALIDATE( '".$aField[1]->getValidator()."',e.id, '".$sField."','".FH_FHTML_DIR."','".FH_INCLUDE_DIR."','".$sMsg."' ); } ) } ); \n";
						}
						else
						{
							$sEvent = 'blur';
						}
						if( $sEvent != '' )
						{
							$sScript  .= "  Event.observe( '".$sField."', '".$sEvent."', function(e ){FH_VALIDATE( '".$aField[1]->getValidator()."', '".$sField."', '".$sField."', '".FH_FHTML_DIR."', '".FH_INCLUDE_DIR."','".$sMsg."' )});\n";
						}
					}
				}
			}
			$sScript  .= "}\n";
			$oForm->_setJS( $sScript );
		}
	}

	function Validate( $aRequest, $oValidator )
	{
		// determin if there is more than one validator
		if( $aRequest['validator'] != '' AND $aRequest['msg'] != '' AND isset( $aRequest['value'] ) )
		{
			if( strpos( $aRequest['validator'], '|' ) > 0 )
			{
				$aValidators = explode( '|', $aRequest['validator'] );
			}
			else
			{
				$aValidators = array( $aRequest['validator'] );
			}

			// loop through validators
			foreach( $aValidators AS $iKey => $sValidator )
			{
				if( method_exists( $oValidator, $sValidator ) AND $sValidator != 'FH_CAPTCHA' )  // CAPTCHA can not be validated by AJAX
				{
					if( $oValidator->$sValidator( $aRequest['value'] ) == false )
					{
						return stripslashes( $aRequest['msg'] );
						exit;  // stop if one validator fails
					}
				}
			}
		}
	}
}
?>